template <typename T>
ATTRIB<T>::ATTRIB(T def)
{
    myDefault = def;
}

template <typename T>
ATTRIB<T>::~ATTRIB()
{
    clear(myDefault);
}

template <typename T>
T
ATTRIB<T>::value(POS pos) const
{
    if (!pos.valid())
	return myDefault;

    int idx = myMaps.find(pos.map());

    if (idx < 0)
	return myDefault;

    return myValues(idx)[pos.x() + pos.y() * pos.map()->width()];
}

template <typename T>
void
ATTRIB<T>::setValue(POS pos, T value)
{
    assert(pos.valid());

    int idx = myMaps.find(pos.map());

    if (idx < 0)
    {
	idx = myMaps.append(pos.map());
	int len = pos.map()->width() * pos.map()->height();
	T *vals = new T[len];
	for (int i = 0; i < len; i++)
	    vals[i] = myDefault;
	myValues.append(vals);
    }

    myValues(idx)[pos.x() + pos.y() * pos.map()->width()] = value;
}

template <typename T>
void
ATTRIB<T>::clear(T value)
{
    for (int i = 0; i < myValues.entries(); i++)
    {
	delete [] myValues(i);
    }
    myMaps.clear();
    myValues.clear();
    
    myDefault = value;
}
