/*
 * Licensed under BSD license.  See LICENCE.TXT  
 *
 * Produced by:	Jeff Lait
 *
 *      	Jacob's Matrix Development
 *
 * NAME:        config.cpp ( Jacob's Matrix, C++ )
 *
 * COMMENTS:
 */

#include <libtcod.hpp>

#include "config.h"

#include <fstream>
using namespace std;

CONFIG *glbConfig = 0;

CONFIG::CONFIG()
{
}

CONFIG::~CONFIG()
{
}

void
CONFIG::load(const char *fname)
{
    TCODParser		parser;
    TCODParserStruct	*screen;

    screen = parser.newStructure("screen");
    screen->addProperty("full", TCOD_TYPE_BOOL, true);

    parser.run(fname, 0);

    myFullScreen = parser.getBoolProperty("screen.full");
}

void
CONFIG::save(const char *fname)
{
    // So TCOD has a parser that does thet hard part,
    // of trying to read in a file.

    // But it has no way to write out a changed version?

    // Argh!
    ofstream		os(fname);

    os << "screen" << endl;
    os << "{" << endl;
    os << "    full = " << (myFullScreen ? "true" : "false") << endl;
    os << "}" << endl;
    os << endl;
}
